const movieServices = require('../services/movies')

exports.getMovieInformations = async (req, res, next) => {
    const filmId = req.params.id;

    try {
        let result = await movieServices.getMovieById(filmId);
        res.status(200).json(result);
    } catch (error) {
        res.status(500).json({ error : error.toString()});
    }
};

exports.searchMovie = async (req, res, next) => {
    let search = req.query.title;

    try {
        let result = await movieServices.searchMovie(search);
        res.status(200).json(result);
    } catch (error) {
        res.status(500).json({ error : error.toString()});
    }
};

// exports.getRecentlyReleasedMovies = (req, res, next) => {
//     const numberOfMovies = req.query.numberOfMovies || 20;

//     db.query('SELECT * FROM Film WHERE releaseDate <= CURDATE() ORDER BY releaseDate DESC LIMIT ?',
//         [parseInt(numberOfMovies)], (error, results, fields) => {
//             if (error) {
//                 res.status(500).json({ error : error.toString()});
//             } else {
//                 res.status(200).json(results);
//             }
//         });
// };

exports.getMovieCast = async (req, res, next) => {
    let filmId = req.params.id;

    try {
        let result = await movieServices.getMovieCast(filmId);
        res.status(200).json(result);
    } catch (error) {
        res.status(500).json({ error : error.toString()});
    }
};

exports.getMovieNote = async (req, res, next) => {
    let filmId = req.query.id;
    let username = req.session.username;

    try {
        let result = await movieServices.getMovieUserRate(filmId,username);
        res.status(200).json(result);
    } catch (error) {
        res.status(500).json({ error : error.toString()});
    }

};

exports.addMovieNote = async (req,res,next) => {
    let filmId = req.query.id;
    let username = req.session.username;
    let note = req.query.note;

    try {
        let result = await movieServices.insertOrUpdateMovieUserRate(filmId,username,note);
        res.status(200).json({ message: 'Note ajoutée ou modifiée' });
    } catch (error) {
        res.status(500).json({ error : error.toString()});
    }

}

exports.deleteMovieNote = async (req,res,next) => {
    let filmId = req.params.id;
    let username = req.session.username;

    try {
        let result = await movieServices.deleteMovieUserRate(filmId,username);
        res.status(200).json({ message: 'Note supprimée' });
    } catch (error) {
        res.status(500).json({ error : error.toString()});
    }

}